/*
**  ClanLib SDK
**  Copyright (c) 1997-2013 The ClanLib Team
**
**  This software is provided 'as-is', without any express or implied
**  warranty.  In no event will the authors be held liable for any damages
**  arising from the use of this software.
**
**  Permission is granted to anyone to use this software for any purpose,
**  including commercial applications, and to alter it and redistribute it
**  freely, subject to the following restrictions:
**
**  1. The origin of this software must not be misrepresented; you must not
**     claim that you wrote the original software. If you use this software
**     in a product, an acknowledgment in the product documentation would be
**     appreciated but is not required.
**  2. Altered source versions must be plainly marked as such, and must not be
**     misrepresented as being the original software.
**  3. This notice may not be removed or altered from any source distribution.
**
**  Note: Some of the libraries ClanLib may link to may have additional
**  requirements or restrictions.
**
**  File Author(s):
**
**    Harry Storbacka
**    Kenneth Gangstoe
**    Magnus Norddahl
*/

#include "GUI/precomp.h"
#include "API/Core/Text/string_format.h"
#include "API/GUI/gui_message.h"
#include "API/GUI/gui_theme_part.h"
#include "API/GUI/Components/groupbox.h"
#include "../gui_css_strings.h"

namespace clan
{

/////////////////////////////////////////////////////////////////////////////
// GroupBox_Impl Class:

class GroupBox_Impl
{
public:

	GroupBox *groupbox;
};

/////////////////////////////////////////////////////////////////////////////
// GroupBox Construction:

GroupBox::GroupBox(GUIComponent *parent)
: GUIComponent(parent, CssStr::GroupBox::type_name), impl(new GroupBox_Impl)
{
	impl->groupbox = this;
}

GroupBox::~GroupBox()
{
}

/////////////////////////////////////////////////////////////////////////////
// GroupBox Attributes:

GroupBox *GroupBox::get_named_item(GUIComponent *reference_component, const std::string &id)
{
	GroupBox *object = NULL;
	if (reference_component)
		object = dynamic_cast<GroupBox*>(reference_component->get_named_item(id));

	if (!object)
		throw Exception(string_format("Cannot find GroupBox named item: %1", id));

	return object;
}
/////////////////////////////////////////////////////////////////////////////
// GroupBox Operations:

/////////////////////////////////////////////////////////////////////////////
// GroupBox Implementation:


}
